/*
 * OS5Sample4OS4.c
 *
 * main file for OS5 Sample4 OS4
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#include <PalmOS.h>
#include <PalmOSGlue.h>

#include "OS5Sample4OS4.h"
#include "OS5Sample4OS4_Rsc.h"

#define ANIMATE_INTERVAL 2	// ʂԊuTicksŕ\B2Ticks=20msec 

#define NUM_STARS 1000;  // ʓ̐̐

//@̏ԂL^\
typedef struct {
	Int16 x;		// XW 0..159
	Int16 y;		// YW*VERTICAL_RESOLUTIONl@0..1599
	Int16 y_speed;@// Y̑xVERTICAL_RESOLUTION{2..8
	Int16 flash_interval; //@_ŊԊu
	Int16 time_remain_to_flash; // ɓ_łOł̕`
	Int16 current_state_of_flash;@// ݂̓_ŏ
	IndexedColorType color;		// ̐F(0..215)
} StarType;

#define METHOD_SAFE 0	// SAFEȕ`@
#define METHOD_FAST 1	// FASTȕ`@

#define VERTICAL_RESOLUTION 10@// Ỷ𑜓xB1hbg=10ƂB

/*********************************************************************
 * Entry Points
 *********************************************************************/

/*********************************************************************
 * Global variables
 *********************************************************************/
UInt32 last_animated_tick;	//@Ōɕ`s(Tickslj
Int16 num_stars;			// ʓ̐̐
StarType *list_stars;		// 邷\̂ւ̃|C^[

Int16 gMethod; 				// ݂̕`@iMETHOD_SAFE or METHOD_FASTj
Boolean gAnimating; 		// ʕ`悪ON(true)OFFifalse)

/*********************************************************************
 * Internal Constants
 *********************************************************************/

/* Define the minimum OS version we support */
#define ourMinVersion    sysMakeROMVersion(3,0,0,sysROMStageDevelopment,0)
#define kPalmOS20Version sysMakeROMVersion(2,0,0,sysROMStageDevelopment,0)

/*********************************************************************
 * Internal Functions
 *********************************************************************/

/*
 * FUNCTION: GetObjectPtr
 *
 * DESCRIPTION:
 *
 * This routine returns a pointer to an object in the current form.
 *
 * PARAMETERS:
 *
 * formId
 *     id of the form to display
 *
 * RETURNED:
 *     address of object as a void pointer
 */

static void * GetObjectPtr(UInt16 objectID)
{
	FormType * frmP;

	frmP = FrmGetActiveForm();
	return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

// X,YWʏ̃AhXɕϊB
UInt32 ToOffset(Int16 x, Int16 y)
{
	return (UInt32)y / VERTICAL_RESOLUTION * 160 + x;
}

static void MoveStars(Int16 method)
{
	UInt8 *bits;
	Int16 i;
	StarType *star;
	BitmapType *bitmap;
	WindowType *win;
	
	win = WinGetDisplayWindow();
	bitmap = WinGetBitmap( win );
	bits = BmpGetBits( bitmap );
	
	for ( i = 0 ; i < num_stars; i++){
		star = list_stars + i;

//@݉ʂɕ\ꂽAB
		if ( star->current_state_of_flash){
//@ʂ̒ڏ
			if ( method == METHOD_FAST){
				*(bits + ToOffset(star->x, star->y) ) = 0; // Clear
// WinnPalmOS֐g@
			} else if ( method == METHOD_SAFE){ 
				WinSetForeColor(0);
				WinPaintPixel( star->x, star->y / VERTICAL_RESOLUTION );
			}
		}
		
// ֈړB
		star->y += star->y_speed;

// ʂ̉[ɒBĂAʏ㕔		
		if ( star->y > 145 * VERTICAL_RESOLUTION){
			star->y = 20 * VERTICAL_RESOLUTION;
		}
		
// _ŊԊu炷B
		star->time_remain_to_flash --;

// _ł^C~OɂȂH		
		if ( star->time_remain_to_flash <= 0){
// \Ԃ𔽓]
			star->current_state_of_flash = ( star->current_state_of_flash)?0:1;
// _ŊԊu
			star->time_remain_to_flash = star->flash_interval;
		}

// \Ԃł΁Aʂɕ`
		if ( star->current_state_of_flash){
// ʂ̒ڏ
			if ( method == METHOD_FAST){
				*(bits + ToOffset(star->x, star->y) ) = star->color; 
// WinnPalmOS֐g@
			} else if ( method == METHOD_SAFE){
				WinSetForeColor(star->color);
				WinPaintPixel( star->x, star->y / VERTICAL_RESOLUTION);
			}
		}			
	}
}

// xv
static void DoBenchmark( Int16 method)
{
	UInt32 start, stop;
	UInt16 total_sec;
	UInt16 loop;
	char msg[32];
	
	FrmCustomAlert( CustomAlert," Start benchmarking.", "","");

// Jn擾
	start = TimGetTicks();
	
// 200JԂ
	for ( loop = 0; loop < 200; loop++){
		MoveStars( gMethod);
	}

// I擾
	stop = TimGetTicks();

// Ticksbɕϊ	
	total_sec = (stop - start) / SysTicksPerSecond();
	
// ʂ\
	StrPrintF(msg, "Total %d secs", total_sec);
	FrmCustomAlert( CustomAlert, msg,"","");
	
}

static void MainFormDoAnimate()
{
	UInt8 *bits;
	Int16 i;
	StarType *star;
	BitmapType *bitmap;
	WindowType *win;

//@Aj[VONɂȂĂȂΏI	
	if ( gAnimating == false)
		return;

// OAj[VAKvȎԂĂ邩H
// ĂȂΏI
	if ( TimGetTicks() < last_animated_tick + ANIMATE_INTERVAL )
		return;

// ŌɃAj[VL
	last_animated_tick = TimGetTicks();

// Aj[Vs
	MoveStars( gMethod );
}

static void MainFormInit(FormType *frmP)
{
	Int16 i;
	StarType *star;
	num_stars = NUM_STARS;

// ̋L̈m
	list_stars = MemPtrNew( sizeof (StarType ) * num_stars);

// ̏	
	for ( i = 0 ; i < num_stars; i++){
		star = list_stars+i;

// W𗐐Ō
		star->x = SysRandom(0) % 160;
		star->y = ( SysRandom(0) % 125 + 20) * VERTICAL_RESOLUTION;
// Y̑x𗐐Ō
		star->y_speed = SysRandom(0) % 6 + 2;
// _ŊԊu𗐐Ō
		star->flash_interval = SysRandom(0) % 20 + 10 ;
// _Ŏ̏l𗐐Ō
		star->time_remain_to_flash = SysRandom(0) % 10;
//@\Ԃ𗐐Ō
		star->current_state_of_flash =SysRandom(0) % 2;
// F𗐐Ō
		star->color = SysRandom(0) % 216;
	}

// @̏l͍iʒڏj
	gMethod = METHOD_FAST; 

// ͂߂̓Aj[V̓It
	gAnimating = false;
}

/*
 * FUNCTION: MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:
 *
 * command
 *     menu item id
 */

static Boolean MainFormDoCommand(UInt16 command)
{
	Boolean handled = false;

	switch (command)
	{

	}

	return handled;
}

/*
 * FUNCTION: MainFormHandleEvent
 *
 * DESCRIPTION:
 *
 * This routine is the event handler for the "MainForm" of this 
 * application.
 *
 * PARAMETERS:
 *
 * eventP
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed to
 *     FrmHandleEvent
 */

static Boolean MainFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP;

	switch (eventP->eType) 
	{
		case nilEvent:
			MainFormDoAnimate();
			break;
			
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm(frmP);
			MainFormInit(frmP);
			handled = true;
			break;
            
        case frmUpdateEvent:
			/* 
			 * To do any custom drawing here, first call
			 * FrmDrawForm(), then do your drawing, and
			 * then set handled to true. 
			 */
			break;
			
		case ctlSelectEvent:
			if ( eventP->data.ctlSelect.controlID == MainStartButton){
// Aj[VON/OFF𔽓]
				gAnimating = !gAnimating;
				handled = true;
			} else if ( eventP->data.ctlSelect.controlID == MainBenchmarkButton){
// x`}[Ns
				DoBenchmark( gMethod);
			}
			break;
		
		case popSelectEvent:
			if ( eventP->data.popSelect.controlID == MainMethodPopTrigger ){
// `@ύX
				if ( eventP->data.popSelect.selection == 0 ){
					gMethod = METHOD_FAST;
				} else {
					gMethod = METHOD_SAFE;				
				}
			}
			break;
	}
    
	return handled;
}

/*
 * FUNCTION: AppHandleEvent
 *
 * DESCRIPTION: 
 *
 * This routine loads form resources and set the event handler for
 * the form loaded.
 *
 * PARAMETERS:
 *
 * event
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed
 *     to a higher level handler.
 */

static Boolean AppHandleEvent(EventType * eventP)
{
	UInt16 formId;
	FormType * frmP;

	if (eventP->eType == frmLoadEvent)
	{
		/* Load the form resource. */
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);

		/* 
		 * Set the event handler for the form.  The handler of the
		 * currently active form is called by FrmHandleEvent each
		 * time is receives an event. 
		 */
		switch (formId)
		{
			case MainForm:
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;

		}
		return true;
	}

	return false;
}

/*
 * FUNCTION: AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.
 */

static void AppEventLoop(void)
{
	UInt16 error;
	EventType event;

	do 
	{
// Aj[Vs߂Ƀ^CAEgl1Ticks(=0.01bjɐݒ
		EvtGetEvent(&event, 1);

		if (! SysHandleEvent(&event))
		{
			if (! MenuHandleEvent(0, &event, &error))
			{
				if (! AppHandleEvent(&event))
				{
					FrmDispatchEvent(&event);
				}
			}
		}
	} while (event.eType != appStopEvent);
}

/*
 * FUNCTION: AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * RETURNED:
 *     errNone - if nothing went wrong
 */

static Err AppStart(void)
{
	UInt32 width;
	UInt32 height;
	UInt32 depth;
	Boolean enableColor;
	Coord x,y;
	
	WinGetDisplayExtent( &x ,&y);
	
// This program runs only in 160x160x8bit screen mode
	WinScreenMode (winScreenModeGet , &width , &height, &depth, &enableColor);

	if ( ( width != 160) || ( height != 160 ) || ( depth != 8)){
		FrmAlert( NonsupportedScreenAlert);
		return -1;
	}

	return errNone;
}

/*
 * FUNCTION: AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 */

static void AppStop(void)
{
        
	/* Close all the open forms. */
	FrmCloseAllForms();

}

/*
 * FUNCTION: RomVersionCompatible
 *
 * DESCRIPTION: 
 *
 * This routine checks that a ROM version is meet your minimum 
 * requirement.
 *
 * PARAMETERS:
 *
 * requiredVersion
 *     minimum rom version required
 *     (see sysFtrNumROMVersion in SystemMgr.h for format)
 *
 * launchFlags
 *     flags that indicate if the application UI is initialized
 *     These flags are one of the parameters to your app's PilotMain
 *
 * RETURNED:
 *     error code or zero if ROM version is compatible
 */

static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;

	/* See if we're on in minimum required version of the ROM or later. */
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
	{
		if ((launchFlags & 
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
		{
			FrmAlert (RomIncompatibleAlert);

			/* Palm OS versions before 2.0 will continuously relaunch this
			 * app unless we switch to another safe one. */
			if (romVersion < kPalmOS20Version)
			{
				AppLaunchWithCommand(
					sysFileCDefaultApp, 
					sysAppLaunchCmdNormalLaunch, NULL);
			}
		}

		return sysErrRomIncompatible;
	}

	return errNone;
}

/*
 * FUNCTION: PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 * 
 * PARAMETERS:
 *
 * cmd
 *     word value specifying the launch code. 
 *
 * cmdPB
 *     pointer to a structure that is associated with the launch code
 *
 * launchFlags
 *     word value providing extra information about the launch.
 *
 * RETURNED:
 *     Result of launch, errNone if all went OK
 */

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error;

	error = RomVersionCompatible (ourMinVersion, launchFlags);
	if (error) return (error);

	switch (cmd)
	{
		case sysAppLaunchCmdNormalLaunch:
			error = AppStart();
			if (error) 
				return error;

			/* 
			 * start application by opening the main form
			 * and then entering the main event loop 
			 */
			FrmGotoForm(MainForm);
			AppEventLoop();

			AppStop();
			break;
	}

	return errNone;
}
